---

## FIXME! how to do it once only!
## Note: more a reset as next login, will ask to change password...
- name: Check if admin pass already set
  ansible.builtin.stat: path="{{ misp_rootdir }}/.admin_pass_set"
  register: ap
- name: Set admin password
  ansible.builtin.command: "{{ misp_rootdir }}/app/Console/cake Password \"{{ misp_web_user }}\" \"{{ misp_web_pass }}\""
  # ansible.builtin.command: "{{ misp_rootdir }}/app/Console/cake user change_pw \"{{ misp_web_user }}\" \"{{ misp_web_pass }}\""
  become: yes
  become_user: "{{ www_user }}"
  when: not ap.stat.exists
  register: cakep
  failed_when: "'User not found.' in cakep.stdout or 'Error:' in cakep.stderr"
- name: Admin pass set marker
  ansible.builtin.file:
    dest: "{{ misp_rootdir }}/.admin_pass_set"
    mode: '0600'
    state: touch
  when: not ap.stat.exists

# - block:
#     - name: set extra users
#       command: "{{ misp_rootdir }}/app/Console/cake Password {{ item.u }} \"{{ item.p }}\""
#       with_items: "{{ misp_webusers_list }}"
#   when: misp_webusers_list is defined and misp_webusers_list

- import_tasks: misp-key-file.yml

- name: Set local variables in PyMISP/examples/keys.py
  ansible.builtin.lineinfile:
    dest: "{{ misp_rootdir }}/PyMISP/examples/keys.py"
    regexp: "{{ item.re }}"
    line: "{{ item.l }}"
    create: yes
    mode: '0640'
    group: "{{ www_user }}"
  with_items:
    - { re: "^misp_url = .*", l: "misp_url = \"{{ misp_pymisp_base_url | default(misp_base_url) }}\"" }
    - { re: "^misp_key = .*", l: "misp_key = \"{{ userkey }}\"" }
    - { re: '^misp_verifycert = .*', l: "misp_verifycert = {{ misp_pymisp_verifycert }}" }
  no_log: "{{ misp_no_log }}"

- name: Flush handlers as we need service up for API call
  ansible.builtin.meta: flush_handlers

- name: Wait for MISP port to be opened
  ansible.builtin.wait_for:
    host: "{{ misp_base_ip }}"
    port: "{{ misp_base_port }}"
    timeout: 300

- name: Ensure PyMISP API working
  ansible.builtin.command: "{{ misp_virtualenv }}/bin/python ./last.py -l 10"
  become: yes
  become_user: "{{ www_user }}"
  args:
    chdir: "{{ misp_rootdir }}/PyMISP/examples"
  environment:
    debug: 'True'
    PYTHONPATH: /usr/local/lib/python3.6/site-packages
  register: test
  changed_when: false
  ignore_errors: true

- name: List current users
  ansible.builtin.command: "{{ misp_virtualenv }}/bin/python ./users_list.py"
  become: yes
  become_user: "{{ www_user }}"
  args:
    chdir: "{{ misp_rootdir }}/PyMISP/examples"
  environment:
    PYTHONPATH: /usr/local/lib/python3.6/site-packages
  register: listusers
  changed_when: false

- name: Add users
  when: misp_webusers_list is defined and misp_webusers_list != []
  block:
    - include_tasks: misp-add-user.yml
      vars:
        user: "{{ item }}"
        list: "{{ listusers }}"
      with_items: "{{ misp_webusers_list }}"
